﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.Domain;
using Kreta.Enums.ManualEnums;
using Kreta.Resources;

namespace Kreta.Web.Areas.KirImportExport.Models.KirImport
{
    public class KirGridModel : IKretaIdentity
    {
        public string ID { get; set; }

        [Display(Name = nameof(KirImportExportResource.Nev), ResourceType = typeof(KirImportExportResource))]
        public string Nev { get; set; }

        [Display(Name = nameof(KirImportExportResource.OktatasiAzonosito), ResourceType = typeof(KirImportExportResource))]
        public string OktatasiAzonosito { get; set; }

        [Display(Name = nameof(KirImportExportResource.SzuletesiIdo), ResourceType = typeof(KirImportExportResource))]
        public DateTime SzuletesiIdo { get; set; }

        [Display(Name = nameof(KirImportExportResource.SzuletesiHely), ResourceType = typeof(KirImportExportResource))]
        public string SzuletesiHely { get; set; }

        [Display(Name = nameof(KirImportExportResource.Statusz), ResourceType = typeof(KirImportExportResource))]
        public string ValtozottString { get; set; }

        public KirEditableEnum Szerkesztheto { get; set; }

        public static implicit operator KirGridModel(KirFelhasznalo kirAlkalmazott) => new KirGridModel
        {
            ID = kirAlkalmazott.Id.ToString(),
            Nev = kirAlkalmazott.NyomtatasiNev ?? $"{kirAlkalmazott.NevElotag} {kirAlkalmazott.SzuletesiNev}",
            OktatasiAzonosito = kirAlkalmazott.OktatasiAzonosito,
            SzuletesiHely = kirAlkalmazott.SzuletesiHely,
            SzuletesiIdo = kirAlkalmazott.SzuletesiDatum.Value,
        };
    }
}
