﻿using System.ComponentModel.DataAnnotations;
using Kreta.Core.KIR.Domain.Model;
using Kreta.Resources;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.KirImportExport.Models.KirImport
{
    public class KirLoginModel
    {
        [Display(Name = nameof(KirImportExportResource.IntezmenyAzonosito), ResourceType = typeof(KirImportExportResource))]
        public string IntezmenyAzonosito { get; set; } = ClaimData.OrganizationCode;

        [Required(ErrorMessageResourceName = nameof(ErrorResource.AFelhasznalonevMegadasaKotelezo), ErrorMessageResourceType = typeof(ErrorResource))]
        [Display(Name = nameof(KirImportExportResource.KirFelhasznaloNev), ResourceType = typeof(KirImportExportResource))]
        public string FelhasznaloNev { get; set; }

        [Required(ErrorMessageResourceName = nameof(ErrorResource.JelszoMegadasaKotelezo), ErrorMessageResourceType = typeof(ErrorResource))]
        [Display(Name = nameof(KirImportExportResource.KirJelszo), ResourceType = typeof(KirImportExportResource))]
        public string Jelszo { get; set; }

        public string Url { get; set; }

        public static implicit operator AuthHeaderModel(KirLoginModel kirLoginModel) => new AuthHeaderModel
        {
            Intezmeny = kirLoginModel.IntezmenyAzonosito,
            FelhasznaloNev = kirLoginModel.FelhasznaloNev,
            Jelszo = kirLoginModel.Jelszo
        };
    }
}
