﻿using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.KirImportExport.Models.KirImport
{
    public class KirSearchModel
    {
        [Display(Name = nameof(KirImportExportResource.Nev), ResourceType = typeof(KirImportExportResource))]
        public string NevSearch { get; set; }

        [Display(Name = nameof(KirImportExportResource.OktatasiAzonosito), ResourceType = typeof(KirImportExportResource))]
        public string OktatasiAzonositoSearch { get; set; }

        [Display(Name = nameof(KirImportExportResource.SzuletesiIdo), ResourceType = typeof(KirImportExportResource))]
        public DateTime? SzuletesiDatumTol { get; set; }

        [Display(Name = nameof(KirImportExportResource.SzuletesiIdo), ResourceType = typeof(KirImportExportResource))]
        public DateTime? SzuletesiDatumIg { get; set; }

        [Display(Name = nameof(KirImportExportResource.SzuletesiHely), ResourceType = typeof(KirImportExportResource))]
        public string SzuletesiHelySearch { get; set; }

        [Display(Name = nameof(KirImportExportResource.Statusz), ResourceType = typeof(KirImportExportResource))]
        public int? StatuszSearch { get; set; }

        [Display(Name = nameof(KirImportExportResource.KirTelephely), ResourceType = typeof(KirImportExportResource))]
        public int? KirTelephelyId { get; set; }

        public static implicit operator FelhasznaloKirSearchCo(KirSearchModel kirImportSearchModel) => new FelhasznaloKirSearchCo
        {
            Nev = kirImportSearchModel.NevSearch,
            OktatasiAzonosito = kirImportSearchModel.OktatasiAzonositoSearch,
            SzuletesiDatumTol = kirImportSearchModel.SzuletesiDatumTol,
            SzuletesiDatumIg = kirImportSearchModel.SzuletesiDatumIg,
            SzuletesiHely = kirImportSearchModel.SzuletesiHelySearch
        };

        public static void ValidateModel(KirSearchModel kirLoginModel)
        {
            if (!kirLoginModel.KirTelephelyId.HasValue)
            {
                throw new Exception("KirTelephelyId kötelező");
            }
        }
    }
}
